TNT2Plugin = null;
var TNT2Framework = {
    QueryInterface: function (aIID) {
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) || aIID.equals(Components.interfaces.nsISupportsWeakReference) || aIID.equals(Components.interfaces.nsISupports)) 
            return this;
        throw Components.results.NS_NOINTERFACE;
    },
    register: function () {
        try{
            gBrowser.addProgressListener(TNT2Framework);
        }catch(e){}
        Components.classes['@mozilla.org/observer-service;1'].getService(Components.interfaces.nsIObserverService).addObserver(TNT2Framework, "http-on-modify-request", false);
    },
    unregister: function () {
        try{
            gBrowser.removeProgressListener(TNT2Framework);
        }catch(e){}
    },

    observe: function (aSubject, aTopic, aData) {
        if ("http-on-modify-request" == aTopic) {
            var httpChannel = aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
            var url = aSubject.URI.spec;
            var headerAccept = httpChannel.getRequestHeader("Accept");
            if (headerAccept.indexOf("text/html") != -1) {
                var matches = url.match(/^http\:\/\/([^\/?#]+)(?:[\/?#]|$)/i);
                var infoUrl = new Object;
                infoUrl.domain = matches && matches[1];
                if (-1 != infoUrl.domain.indexOf('.')) {
                    infoUrl.top = true;
                    infoUrl.url = url;
                    infoUrl.params = new Object;
                    url.replace(/[?&]+([^=&]+)=([^&]*)/gi, function (m, key, value) {
                        infoUrl.params[key] = value;
                    });
                    var newUrl = TNT2Plugin.SendEvent(260, JSON.stringify(infoUrl));
                    if (newUrl != "") {
                        httpChannel.cancel(Components.results.NS_BINDING_ABORTED);
                        gBrowser.loadURI(newUrl);
                    }
                }
            }
        }
    },

    getBrowserFromChannel: function (aChannel) {
        try 
        {
            var notificationCallbacks = aChannel.notificationCallbacks ? aChannel.notificationCallbacks : aChannel.loadGroup.notificationCallbacks;
            if (!notificationCallbacks)
                return null;
            var domWin = notificationCallbacks.getInterface(Components.interfaces.nsIDOMWindow);
            return domWin;
        }
        catch (e) {
            return null;
        }
    },

    onLocationChange: function (aProgress, aRequest, aURI) { 
    },

    onStateChange: function (aWebProgress, aRequest, aStateFlags, aStatus) {
    },

    onProgressChange: function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
    },
    
    onStatusChange: function (aWebProgress, aRequest, aStatus, aMessage) {
    },
    
    onSecurityChange: function (aWebProgress, aRequest, aState) {
    },
    
    onLinkIconAvailable: function (aBrowser) {
    },

    SetNoSandboxing: function () {
        try {
            var svc = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
            if (null != svc)
                svc.setBoolPref("dom.ipc.plugins.enabled.nptnt2.dll", false);
        }
        catch (e) {  }
    },
    navigate: function (uri) {
        try {
            var WinWatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
            var ActiveWin = WinWatcher.activeWindow;
            ActiveWin.loadURI(uri);
        }
        catch (e) {
            try {
                openUILink(uri, null);
            }
            catch (ee) {  }
        }
    },
    newtabnavigate: function (uri) {
        try {
            gBrowser.addTab(uri);
        }
        catch (e) { }
    },
    injectscript: function (source) {
        try {
            var WinWatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
            var myScript = WinWatcher.activeWindow.content.document.createElement('script');
            myScript.type = 'text/javascript';
            myScript.textContent = src;
            WinWatcher.activeWindow.content.document.getElementsByTagName('head')[0].appendChild(myScript);
        }
        catch (e) { }
    },
    enginename: "",
    makedefault: true,
    ff_recheckProvider: function () {
        try {
            var searchService = Components.classes["@mozilla.org/browser/search-service;1"].getService(Components.interfaces.nsIBrowserSearchService);
            var engine = searchService.getEngineByName(enginename);
            if (!engine) {
                setTimeout(ff_recheckProvider, 100);
            }
            else {
                engine.hidden = false;
                searchService.currentEngine = engine;
                searchService.moveEngine(engine, 0);
                var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
                if( makedefault ){
                    var browserSearchPrefBranch = prefs.getBranch('browser.search.');
                    browserSearchPrefBranch.setCharPref('defaultenginename', enginename);
                    browserSearchPrefBranch.setCharPref('selectedEngine', enginename);
                }
            }
        }
        catch (e) { }
    },
    ff_addSearchProvider: function (providerstring) {
        try 
        {
            var provider = eval('(' + providerstring + ')');
            var browserSearchService = Components.classes["@mozilla.org/browser/search-service;1"].getService(Components.interfaces.nsIBrowserSearchService);
            enginename = provider.name;
            try{
                var prvEngine = browserSearchService.getEngineByName(enginename);
                if (prvEngine != null)
                    browserSearchService.removeEngine(prvEngine);
            }catch(e){
            }
            if(provider.yxml != null) {
                if( provider.yname != null){
                    try{
                        var prvYEngine = browserSearchService.getEngineByName(provider.yname);
                        if (prvYEngine != null)
                            browserSearchService.removeEngine(prvYEngine);
                    }catch(e){
                    }
                }
                browserSearchService.addEngine(provider.yxml, Components.interfaces.nsISearchEngine.DATA_XML, null, false);
            }
            if (provider.osxml != null) {
                browserSearchService.addEngine(provider.osxml, Components.interfaces.nsISearchEngine.DATA_XML, null, false);
                setTimeout(this.ff_recheckProvider, 100);
            }
            else {
                browserSearchService.addEngineWithDetails(
                                provider.name,
                                provider.iconURL,
                                provider.alias,
                                provider.description,
                                provider.method,
                                provider.url);
            }
            var myengine = browserSearchService.getEngineByName(enginename);
            if( myengine ) 
                browserSearchService.currentEngine = myengine;
            var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
            if( provider.makedefault != null ){
                makedefault = provider.makedefault;
                if( makedefault ){
                    var browserSearchPrefBranch = prefs.getBranch('browser.search.');
                    browserSearchPrefBranch.setCharPref('defaultenginename', enginename);
                    browserSearchPrefBranch.setCharPref('selectedEngine', enginename);
                }
            }
            if( provider.homep ){
                var donevar = 'tnt' + provider.partner + '.initdone';
                if( !prefs.getPrefType(donevar) ){
                    prefs.setBoolPref(donevar, true);
                    prefs.setCharPref('browser.startup.homepage', provider.homep);
                }
            }
            if( provider.keywordUrl ){
                prefs.setCharPref("keyword.URL", provider.keywordUrl);
            }
        }
        catch (e) { }
    },
    addbookmark: function (url) {
        try {
            var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Ci.nsINavBookmarksService);
            var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
            bmsvc.insertBookmark(bmsvc.unfiledBookmarksFolder, ios.newURI(url, null, null), -1, "some name");
        }
        catch (e) { }
    }
};
TNT2Framework.SetNoSandboxing();
window.addEventListener("load", function () {
    TNT2Framework.register();
}, false);
window.addEventListener("unload", function () {
    TNT2Framework.unregister();
}, false);
setTimeout(function(){
    TNT2Plugin = document.getElementById("TNT2NP");
}, 500);

